function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
var _excluded = ["label", "orgName", "position", "children", "deptNames"];
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import React, { useState, useEffect, useCallback } from 'react';
import classNames from 'classnames';
import iconMap from "../../tree-node-icon";
// import { Tooltip } from 'antd';
import "../index.less";
export default (function (dataSource, searchText, renderExtra) {
  var _useState = useState([]),
    _useState2 = _slicedToArray(_useState, 2),
    treeData = _useState2[0],
    setTreeData = _useState2[1];

  //   const getNodeIcon = useCallback(
  //     (iconType: IconType) => {
  //       return iconMap[iconType];
  //     },
  //     [iconMap],
  //   );
  var generateDataSource = useCallback(
  // (data, search, rootIcon) => {
  function (data, search) {
    if (!data) return undefined;
    return data.map(function (el) {
      var _el$label = el.label,
        label = _el$label === void 0 ? '' : _el$label,
        orgName = el.orgName,
        position = el.position,
        children = el.children,
        deptNames = el.deptNames,
        itemProps = _objectWithoutProperties(el, _excluded);
      var $nodeIcon = null;
      // if (iconType) {
      //   const NodeIcon = getNodeIcon(iconType);
      //   $nodeIcon = <NodeIcon />;
      // }
      var $title = label;
      var matchedIndex = search ? label.indexOf(search) : -1;
      // if (rootIcon) {
      //   const NodeIcon = getNodeIcon(rootIcon);
      //   $nodeIcon = <NodeIcon />;
      // }
      if (matchedIndex >= 0) {
        // 命中了搜索文案，显示高亮内容
        $title = /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("span", {
          key: "before"
        }, label.slice(0, matchedIndex)), /*#__PURE__*/React.createElement("span", {
          key: "keyword",
          className: "highlight"
        }, search), /*#__PURE__*/React.createElement("span", {
          key: "after"
        }, label.slice(matchedIndex + search.length)));
      }
      var extraEl = typeof renderExtra === 'function' ? renderExtra(el) : null;
      return _objectSpread(_objectSpread({}, itemProps), {}, {
        //   iconType,
        title:
        /*#__PURE__*/
        // <Tooltip placement="topLeft" title={label}>
        React.createElement("div", {
          className: "treeNode",
          title: label
        }, $nodeIcon, /*#__PURE__*/React.createElement("div", {
          className: "nodeContent"
        }, /*#__PURE__*/React.createElement("div", {
          className: "titleWrapper"
        }, /*#__PURE__*/React.createElement("div", {
          className: classNames('title', {
            // 搜索出来的文案换行，普通节点超长省略
            noWrap: !searchText,
            wrap: !!searchText
          })
        }, $title), position ? /*#__PURE__*/React.createElement("div", {
          className: "position"
        }, "(", position, ")") : null), /*#__PURE__*/React.createElement("p", {
          className: "orgName"
        }, orgName, (deptNames || []).join(', ')), extraEl))
        // </Tooltip>
        ,
        // 渲染子节点，这里不透传 rootIcon，因为该配置只作用于根节点
        children: generateDataSource(children, search)
      });
    });
  }, [iconMap, searchText]);
  useEffect(function () {
    // 非搜索场景下，如果传入 rootIconType，则特殊处理根节点 icon
    setTreeData(generateDataSource(dataSource, searchText, null));
  }, [dataSource, searchText]);
  return [treeData];
});